package com.jiuqi.util;

import java.util.Collection;
import java.util.ArrayList;
import java.util.List;
import java.util.Stack;

public class SortList
{
    private Stack cacheItems;
    private List sortItems;
    
    public SortList() {
        this.cacheItems = new Stack();
        this.sortItems = new ArrayList();
    }
    
    public void reset() {
        this.cacheItems.addAll(this.sortItems);
        this.sortItems.clear();
    }
    
    public void addItem(final Object key, final int identy) {
        SortItem si = null;
        if (this.cacheItems.empty()) {
            si = new SortItem(key, identy);
        }
        else {
            si = this.cacheItems.pop();
            si.key = key;
            si.identy = identy;
        }
        this.sortItems.add(si);
    }
    
    public void addItem(final Object key, final Object value) {
        SortItem si = null;
        if (this.cacheItems.empty()) {
            si = new SortItem(key, value);
        }
        else {
            si = this.cacheItems.pop();
            si.key = key;
            si.value = value;
        }
        this.sortItems.add(si);
    }
    
    public void sort(final boolean desc) {
        JqLib.listSort(this.sortItems);
        if (desc) {
            JqLib.listRevert(this.sortItems);
        }
    }
    
    public int size() {
        return this.sortItems.size();
    }
    
    public Object getKey(final int index) {
        return this.sortItems.get(index).key;
    }
    
    public int getIdenty(final int index) {
        return this.sortItems.get(index).identy;
    }
    
    public Object getValue(final int index) {
        return this.sortItems.get(index).value;
    }
    
    public int findAsc(final Object key) {
        SortItem si = null;
        synchronized (this.cacheItems) {
            if (!this.cacheItems.empty()) {
                si = this.cacheItems.pop();
                si.key = key;
                si.identy = 0;
            }
            monitorexit(this.cacheItems);
        }
        if (si == null) {
            si = new SortItem(key, 0);
        }
        final int result = JqLib.listFind(this.sortItems, si);
        this.cacheItems.add(si);
        return result;
    }
    
    public int indexOfIdenty(final int identy) {
        for (int i = 0; i < this.sortItems.size(); ++i) {
            final SortItem si = this.sortItems.get(i);
            if (si.identy == identy) {
                return i;
            }
        }
        return -1;
    }
    
    public int indexOfValue(final Object value) {
        for (int i = 0; i < this.sortItems.size(); ++i) {
            final SortItem si = this.sortItems.get(i);
            if (si.value == value || (value != null && value.equals(si.value))) {
                return i;
            }
        }
        return -1;
    }
}
